#version 330 core
out vec4 color;
in vec3 vnormal;
in vec3 vpos;
in vec2 vtex;
in vec3 verpos;
uniform vec3 campos;

void main()
{
	vec3 origin = vec3(0,-0.25,0);
	float dis = distance(origin.xy, verpos.xy);

	vec3 n = normalize(vnormal);
	vec3 lp=vec3(10,-20,-100);
	vec3 ld = normalize(vpos - lp);
	float diffuse = dot(n,ld);

	if (dis < 0.375 && dis > 0.35 && verpos.x < 0.275 && verpos.x > -0.275 && verpos.y < -0.25 && verpos.z > 0) {
		color.rgb = vec3(0,0,0);
	}
	else {
		color.rgb = vec3(0.988, 0.533, 0.435); //Patrick Color: (252, 136, 111)
	}

	color.rgb = color.rgb*diffuse*0.3 + color.rgb*0.7;
	color.a = 1;
}
