#version 330 core
out vec4 color;
in vec3 vnormal;
in vec3 vpos;
in vec2 vtex;
in vec3 verpos;
uniform vec3 campos;

void main()
{
	vec3 n = normalize(vnormal);
	vec3 lp = vec3(10,-20,-100);
	vec3 ld = normalize(vpos - lp);
	float diffuse = dot(n,ld);

	color.rgb = vec3(0.1765, 0.6275, 0.0); //Green (45, 160, 0)
	color.rgb = color.rgb*diffuse*0.25 + color.rgb*0.75;

	vec3 cd = normalize(vpos - campos);
	vec3 h = normalize(cd+ld);
	float spec = dot(n,h);
	spec = clamp(spec,0,1);
	spec = pow(spec,20);
	color.rgb += vec3(0.2745, 1.0, 0.0)*spec*3; //Light Green (70, 255, 0)
	color.a = 1;
}
