#version 330 core
out vec4 color;
in vec3 vnormal;
in vec3 vpos;
in vec2 vtex;
in vec3 verpos;
uniform vec3 campos;

void main()
{
	if (vpos.y < -0.5f || vpos.y > 6.0f) {
		discard;
	}

	vec3 n = normalize(vnormal);
	vec3 lp = vec3(10,-20,-100);
	vec3 ld = normalize(vpos - lp);
	float diffuse = dot(n,ld);

	color.rgb = vec3(0.059, 0.0, 0.824); //Blue (15, 0, 210)
	color.rgb = color.rgb*diffuse*0.35 + color.rgb*0.65;

	vec3 cd = normalize(vpos - campos);
	vec3 h = normalize(cd+ld);
	float spec = dot(n,h);
	spec = clamp(spec,0,1);
	spec = pow(spec,20);
	color.rgb += vec3(0.294, 0.255, 1.0)*spec*3; //Lighter Blue (75, 65, 255)

	color.a = 1;
}
