#version 330 core
out vec4 color;
in vec3 vnormal;
in vec3 vpos;
in vec2 vtex;
in vec3 verpos;
uniform vec3 campos;

void main()
{
	vec3 origin = vec3(0,0,0);
	float dis = distance(origin.xz, verpos.xz);

	vec3 n = normalize(vnormal);
	vec3 lp = vec3(10,-20,-100);
	vec3 ld = normalize(vpos - lp);
	float diffuse = dot(n,ld);

	if (dis > 0.625 && verpos.y > -0.725) {
		color.rgb = vec3(0.882, 0.431, 0.039); //Orange-Brown Shirt: (225, 110, 10)
	}
	else {
		color.rgb = vec3(0.608, 0.882, 0.902); //Squidward Blue: (155, 225, 230)
	}
	
	color.rgb = color.rgb*diffuse*0.3 + color.rgb*0.7;
	color.a = 1;
}
