#version 330 core
layout(location = 0) in vec3 vertPos;
layout(location = 1) in vec2 vertTex;

uniform mat4 P;
uniform mat4 V;
uniform mat4 M;
out vec3 vpos;
out vec2 vtex;
uniform sampler2D tex5;

void main()
{
	vec2 texcoords=vertTex;
	float height = texture(tex5, texcoords).r;
	height *= 10.0-3;

	vec4 tpos =  vec4(vertPos, 1.0);
	tpos =  M * tpos;

	tpos.x -= 1;
	tpos.y -= 2;
	tpos.z += 23;

	if (tpos.z > 25) {
		tpos.y += height;
	} 
	else {
		tpos.y = -0.5f;	
	}

	vpos = tpos.xyz;

	gl_Position = P * V * tpos;
	vtex = vertTex;
}
